Core Utilities
lariv.utils
Core utilities and helper functions for string formatting, database connection parsing, migration operations, and subprocess execution.
AddFieldToOtherApp
Bases: Operation
Add a field to a model in another app (used by connector apps).
Source code in lariv/utils.py
144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 | |
AlterFieldInOtherApp
Bases: Operation
Alter a field on a model in another app (used by connector apps).
Source code in lariv/utils.py
196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 | |
convert_m2m(v)
Convert a Django ManyRelatedManager or similar iterable to a standard Python list.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
v
|
The value to convert. |
required |
Returns:
| Name | Type | Description |
|---|---|---|
list |
A list representation of the provided value. |
Source code in lariv/utils.py
20 21 22 23 24 25 26 27 28 29 30 31 32 | |
format_datetime(dt, fmt='%B %d, %Y at %I:%M %p')
Format a datetime object into a readable string using the server's local timezone.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
dt
|
datetime
|
The datetime to format. |
required |
fmt
|
str
|
The strftime format to use. |
'%B %d, %Y at %I:%M %p'
|
Returns:
| Name | Type | Description |
|---|---|---|
str |
str
|
The formatted datetime string. |
Source code in lariv/utils.py
295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 | |
get_db_uri(connection_alias='default')
Constructs an SQLAlchemy-compatible database URI from Django's DATABASES setting.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
connection_alias
|
str
|
The Django database alias to resolve. Defaults to "default". |
'default'
|
Returns:
| Name | Type | Description |
|---|---|---|
str |
str
|
The constructed connection URI (e.g., |
Source code in lariv/utils.py
101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 | |
pascalcase(input)
Convert a snake_case or space-separated string into PascalCase.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
input
|
str
|
The string to format. |
required |
Returns:
| Name | Type | Description |
|---|---|---|
str |
str
|
The PascalCase string. |
Source code in lariv/utils.py
67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 | |
run_exe(command, args, cwd, env, wait_for_end=False)
Runs an executable as a subprocess cleanly handling paths and environments.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
command
|
str
|
the name of the executable to run (resolved via |
required |
args
|
list[str]
|
list of arguments to be passed into the command. |
required |
cwd
|
str
|
absolute path for the working directory of the process. |
required |
env
|
dict[str, str]
|
additional environment variables beyond |
required |
wait_for_end
|
bool
|
whether to block and wait for execution to complete or spawn detached. |
False
|
Raises:
| Type | Description |
|---|---|
ValueError
|
In case the command binary could not be found via the system PATH. |
Exception
|
Re-raises any exceptions generated by |
Source code in lariv/utils.py
312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 | |
table_page_range(page)
Calculate windowed pagination ranges for rendering table footers (e.g., [1, 2, 3, 4] or [[1], [4,5,6], [10]]).
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
page
|
A Django pagination |
required |
Returns:
| Type | Description |
|---|---|
list[list[int]]
|
list[list[int]]: A list of page number blocks used to render pagination gaps. |
Source code in lariv/utils.py
242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 | |
titlecase(input)
Convert a snake_case, camelCase, or pascalCase string into space-separated Title Case.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
input
|
str
|
The string to format. |
required |
Returns:
| Name | Type | Description |
|---|---|---|
str |
str
|
The Title Cased string. |
Source code in lariv/utils.py
38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 | |
update_url(url, **kwargs)
Update or append URL query parameters safely.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
url
|
str
|
The original URL. |
required |
**kwargs
|
The query string parameters to add or override. |
{}
|
Returns:
| Name | Type | Description |
|---|---|---|
str |
str
|
The updated URL. |
Source code in lariv/utils.py
276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 | |